require 'fileutils'
require 'pathname'
require 'yaml'
require 'gill/cli'

module Gill

  class << self
    include CLI
  end

  #
  # Gill config setter method
  # 
  # @param [Object] config Settings::Config Object
  #
  def Gill.config=(config=nil)
    @config = config
  end

  #
  # Gill config getter method
  # 
  # @return [Object] Settings::Config Object
  #
  def Gill.config
    return @config if defined?(@config)
    Gill.config = Settings::Config.new
  end

  #
  # Setup
  # 
  # Load the gill configuration 
  # files and parse options.
  #
  def Gill.setup
    Gill.config
    Gill.config.clean_cache
    optparse(*ARGV)
  end

end
